/* -----------------------------------------------------------------------
 *
 * Project:     UT-SNMP
 * Filename:    apiMSG.h
 * Date:        September 1994
 * Purpose:     include file for MSG.c
 * Author(s):   Vincent Berkhout, Frederic P. H. van Hengstum
 *
 * -----------------------------------------------------------------------
 */

#ifndef APIMSG_H
#define APIMSG_H

#include <UT-SNMP.h>


#define NAMEMAX	256
#define	VARSMAX (4*1024) 	/* don't know ... */


/*
 *	Message definition for communication between UT-APPLICATION 
 *	and UT-SPM ...
 */
typedef struct {
	
	AsnInt  size;

	AsnInt	id;

 	AsnInt	type; 

	AsnInt	taddressLen;			/* or name */
	AsnOct	taddress[NAMEMAX];      

	AsnInt	qos;					/* or role */

	AsnInt	etype;    				/* or non-repeaters (nonR) or status */
	AsnInt	eindex;     			/* or max-repetitions (maxR) */

	AsnInt	lbLen;					/* lower-bound subtree */
	AsnOct	lb[NAMEMAX];

	AsnInt	ubLen;					/* upper-bound subtree */
	AsnOct	ub[NAMEMAX];

	AsnInt	cleLen;
	AsnOct	cle[NAMEMAX];

	AsnInt	cltLen;
	AsnOct	clt[NAMEMAX];

	AsnOct	vars[VARSMAX];

} IPC_MSG;


/*
 *	Interface routine to operate on IPC_MSG ...
 */
EXTERN STATUS msgOpen( AsnInt *handle );
EXTERN STATUS msgPut( AsnInt *handle,
        AsnInt *id, AsnInt *type, AsnOcts *taddress, AsnInt *qos,
        AsnInt *etype, AsnInt *eindex, AsnOid *lb, AsnOid *ub,
        AsnOcts *cle, AsnOid *clt, AsnVbl *vars );
EXTERN STATUS msgGet( AsnInt *handle,
        AsnInt *id, AsnInt *type, AsnOcts *taddress, AsnInt *qos,
        AsnInt *etype, AsnInt *eindex, AsnOid *lb, AsnOid *ub,
        AsnOcts *cle, AsnOid *clt, AsnVbl *vars );
EXTERN STATUS msgClose( AsnInt handle );




#endif	/* APIMSG_H */

