/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:    per_buf.h
 *
 * Date:        May 1994.
 *
 * Purpose:     Interface to PER modules.
 *
 * Author(s):   Rene Oude Vrielink
 *
 * -----------------------------------------------------------------------
 */
#ifndef _per_buf_h
#define _per_buf_h

#define PerGetByte(b)\
    (unsigned char)(*((*(b))++))

#define PerPeekByte( b)  (unsigned char) (**(b))

#define PerGetSeg( b, lenPtr)\
    *(b);\
    (*b) += *lenPtr;

#define PerCopy( dst, b, len)\
    memcpy((dst), *(b), (len));\
    (*(b)) += (len);

#define PerSkip( b, len) ((*(b)) += len)

#define PerPutByte( b,  byte)\
    (*(--(*(b))) = (byte))

#define PerPutSeg( b, data, len)\
    ((*(b)) = (*(b)) - (len));\
    memcpy(*(b), (data), (len));

#endif /* conditional include */
