/* -----------------------------------------------------------------------
 *
 * Project:		UT-SNMP
 *
 * Filename:    simTF.SHM.h
 *
 * Date:        July 1994
 *
 * Purpose:	
 *
 * Author(s):	Vincent Berkhout, Frederic P. H. van Hengstum,
 *
 * -----------------------------------------------------------------------
 */

#ifndef SPMSHM_H
#define SPMSHM_H

#include <sim.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/shm.h>


/*
 *	EXTERNAL FUNCTIONS (, more forward reference intented)
 */
extern STATUS P();
extern STATUS V();
extern STATUS PM();
extern STATUS VM();



/*
 *	CONSTANTS.
 */
#define SHMMAX		(64*1024)
#define COMMANDMAX 	(256)
#define CONNECTMAX	(100)
#define commandPrefix	"/usr/bin/touch /tmp/.ipc."
#define pathPrefix	"/tmp/.ipc."

#define channel1	0
#define channel2	1
#define semREAD		0
#define semWRITE	1
#define GETVAL		5
#define SETVAL		8
#define SPMMUTEX   	0
#define APIMUTEX   	1
#define INITMUTEX 	20



/*
 *	TYPE DEFINITIONS.
 */
typedef char 	ICOMMAND[COMMANDMAX];
typedef char 	IPATH[COMMANDMAX];



/*
 *	TABLE DECLARATION
 */
typedef struct {
	int 	handle;
	char 	address[256];
	int 	shmid1,
		shmid2,
		semid;
	void 	*shmem1,
		*shmem2;
} CONNECTTABLE[CONNECTMAX];
static CONNECTTABLE	connectTable;

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
} arg;
struct sembuf {
	ushort  sem_num;        /* semaphore # */
	short   sem_op;         /* semaphore operation */
	short   sem_flg;        /* operation flags */
};

static BOOLEAN SNMP_DEBUG_spmSHM = TRUE;

EXTERN STATUS shmPassiveOpen( char *localAddress, int *handle );
EXTERN STATUS shmActiveOpen( char *localAddress, char *Address, int *handle );
EXTERN STATUS shmAcceptOpen( char *localAddress, char *Address, int *handle );
EXTERN STATUS shmSend( int handle, char *message );
EXTERN STATUS shmReceive( int handle, char *message );
EXTERN STATUS shmClose( int handle );
EXTERN STATUS shmFileClose( char *localAddress );
EXTERN STATUS shmRemoteExist( char *Address );


#endif /* ! SPMSHM_H */

/* -----------------------------------------------------------------------
 */
