/* -----------------------------------------------------------------------
 *
 * Project:     UT-SNMP
 *
 * Filename:    spmPERV2.h
 *
 * Date:        May 1994.
 *
 * Purpose:     Interface to PERV2 module.
 *
 * Author(s):   Rene Oude Vrielink
 *
 * -----------------------------------------------------------------------
 */

#ifndef SPMPER2_H
#define SPMPER2_H

#include <snmpTypes.h>

#ifndef UNAUTH
#define	UNAUTH	0
#endif

#ifndef AUTH
#define AUTH	1
#endif


EXTERN STATUS SpmInitPer PROTO(());

EXTERN STATUS PerDecodePrivMsg PROTO(( AsnOcts *privMsg, 
			AsnOid **privDst, AsnOcts **privData )) ;

EXTERN STATUS PerDecodeAuthMsg PROTO(( AsnOcts *authMsg, AsnOcts **authDigest,
			AsnInt *authDstTimestamp, AsnInt *authSrcTimestamp,
			AsnLen *authDigestOffset, AsnOcts **authData ));

EXTERN STATUS PerDecodeCommMsg PROTO(( AsnOcts *commMsg, AsnOid **srcParty, AsnOid **dstParty,
			AsnOid **context, AsnOcts **pdu, PDUsChoiceId *tag ));

EXTERN STATUS PerDecodePdu PROTO(( AsnOcts *pdu, PDUsChoiceId *tag,
			AsnInt *requestid, AsnInt *errorstatus, AsnInt *errorindex,
			VarBindList **varbindlist ));


EXTERN STATUS PerEncodePrivMsg PROTO(( AsnOid *privDst, AsnOcts *privData, 
			AsnOcts **snmpPrivMsg));

EXTERN STATUS PerEncodeAuthMsg PROTO(( AsnOcts *authDigest, AsnInt authDstTimestamp,
		       	AsnInt authSrcTimestamp, AsnLen *authDigestOffset,
		    	AsnOcts *authData, AsnOcts **authMsg));

EXTERN STATUS PerEncodeMgmtCom PROTO((	AsnOid *srcParty, AsnOid *dstParty, AsnOid *context,
		 	PDUsChoiceId tag, AsnInt request_id, AsnInt errorstatus,
			AsnInt errorindex, VarBindList *variablebindings,
		   	AsnOcts  **authData));

#endif /* SPMPE2R_H */

/* ---------------------------- end of file spmPer2.h ----------------------- */
