/* -----------------------------------------------------------------------
 *
 * Project: 	UT-SNMP
 *
 * Filename:    yp2.h
 *
 * Date:        September 1994
 *
 * Purpose:     headerfile for yp3
 *
 * Author(s):   Frederic P. H. van Hengstum, Vincent Berkhout
 *
 * -----------------------------------------------------------------------
 */

#ifndef YP2_H
#define YP2_H

#include <snmpTypes.h>

#define YP2INLISTTIMEOUT 	(5*60)				/* in seconds */
#define YP2OUTLISTTIMEOUT 	(5*60)				/* in seconds */

#define YP2INLISTMAX 		(15)
#define YP2OUTLISTMAX 		(15)

/*
 *  Generic definition of IN-list.
 */
typedef struct {
    AsnInt 	id, 
			src, 
			dst, 
			ctx, 
			timestamp;
} YP2INLIST[ YP2INLISTMAX ];
YP2INLIST yp2inlist;

/*
 *  Generic definition of OUT-list.
 */
typedef struct {
    AsnInt 	id, 
			type, 
			timestamp;
} YP2OUTLIST[ YP2OUTLISTMAX ];
YP2OUTLIST yp2outlist;

#endif /* YP2_H */

