/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:	snmpInitAgentUser.c
 *
 * Date:	May 1994
 *
 * Purpose:
 *
 * Author:	Michel van Ooijen & Edward Veluwenkamp
 *
 * Remarks:
 *
 * -----------------------------------------------------------------------
 */
 


/* -----------------------------------------------------------------------
 *  include files
 * -----------------------------------------------------------------------
*/
#include <snmpInitAgent.h>
#include <snmpInitAgentUser.h>

 
/* -----------------------------------------------------------------------
 *  Function:  getipaddresshostname
 *  Arguments: kindmess, initial int (IN)
	       ipaddress, (OUT) 
	       name (IN) 
 *  Purpose:   Gets IPaddress of the system with hostname = name  
 *  Remarks:    
 * -----------------------------------------------------------------------
*/
void UINgetipaddresshostname(kindmess,ipaddress,name)
 int   kindmess;
 char *ipaddress,*name;
{
  char bool1,ch;
  int  i;
 
  do {
    if( gethostname( name,HOSTNAMELEN) == -1 ) {
	perror( "gethostname" );
	exit( -1 );
      }
    switch (kindmess) {
      case 0 : 
	fprintf( stdout,
		 "\t1) Hostname of management system [%s]: ", name );
	break;
      case 1 : 
	fprintf( stdout,
		 "\t2) Hostname of agent system [%s]: ", name );
	break;
      }
    fflush(stdin);
    i = 0;
    ch = name[0];
    do {
       	name[i++] = getchar(); 
    } while (name[i-1] != '\n');
    if (name[0] == '\n') {
	name[0] = ch;
	SINgetipaddress(ipaddress);
        bool1 = '0';
    } else { 
        name[i-1] = '\0';
        if (SINgetipadrname(ipaddress,name) == 0)
         	bool1 = '0';
        else {
           	fprintf( stdout,
			 "\t\tERROR: invalid hostname/internet address.\n",
			 name );
            	bool1 = '1';
         }
    }
  } while (bool1 != '0');
}



/* -----------------------------------------------------------------------
 *  Function:  	UINgetint
 *  Arguments:  none 
 *  Purpose:   	This function reads an integer.
 *  Remarks:    return value is a integer which is read from the input device 
 * -----------------------------------------------------------------------
*/
int UINgetint()
{ 
	int intAr[INTARRLEN];
	char charAr[INTARRLEN];
     	int i=0; 

     	do {
       		intAr[i] = getchar();
       		i++;
      	} while( (intAr[i-1] != '\n') && (i < INTARRLEN) );
     	intAr[i-1] = '\0';
        i = 0;
     	while (intAr[i] != '\0') {
           if (isdigit(intAr[i]) == 0) 
	     return( -1 );
           else charAr[i] = (char) intAr[i];
           i++;
        }
        charAr[i] = '\0'; 
     	return( atoi( (const char *) charAr ) );
}

/* -----------------------------------------------------------------------
 *  Function:  createhostname
 *  Arguments: kindmess, (IN)
	       hostname, (IN/OUT)
	       num (IN) 
 *  Purpose:   create a hostname to identify the application and used system 
 *  Remarks:   
 * -----------------------------------------------------------------------
*/
void UINcreatehostname(kindmess,hostname,num)
 char *hostname;
 int   kindmess,*num;
 {
  int check=0,four,i;
  char chnum[ARLEN];
  
  switch(kindmess)
   {
    case 0:printf("\nThe following Manager(s) exists\n\n");break;
    case 1:printf("\nThe following Agent(s) exist\n\n");break;        
   } 
  while (check < MAXAPPL)
   {
    four = 0;
    for(i=0;i<lengthEntry;i++)
     {
       if (num[i] == check) four++;
     }
    if (four == 4)
       switch(kindmess)
         {
           case 0:printf("Manager %s%d\n",hostname,check);break;
           case 1:printf("Agent %s%d\n",hostname,check);break;        
         }
    check++;
   }
   printf("\nGive number to identify application, default[0] :");
   sprintf(chnum,"%d",UINgetint());
   strcat(hostname,chnum);
  }
 

/* -----------------------------------------------------------------------
 *  Function:  ipaddresshostname
 *  Arguments: kindmess, (IN)
               ipaddress, (OUT)
	       hostname (OUT) 
 *  Purpose:   to find ipaddress and hostname to identify an appliction uniquely 
 *  Remarks:   returns ipaddress and hostname
 * -----------------------------------------------------------------------
*/
void UINipaddresshostname(kindmess,ipaddress,hostname)
int   kindmess;
char *ipaddress,*hostname;
 {
  /* char  *cmd = "/usr/bin/ls ", buf[BUFSIZE], numberarr[ARLEN];
  int    num[lengthEntry];
  FILE  *ptr;
  int    i,j,k,number;
  char filename[FILELEN]; */

  UINgetipaddresshostname(kindmess,ipaddress,hostname);
/*  if (kindmess == 0) strcat (hostname,"_M",2);
  if (kindmess == 1) strcat (hostname,"_A",2);
  for (k=0;k<lengthEntry;k++) num[k]= -1;
  k=0;
  strcpy(filename,cmd);
  strcat(filename,CMU_PATH);
  if ((ptr = popen(filename, "r")) != NULL)
       while (fgets(buf, BUFSIZE, ptr) != NULL)
         {
          if (strncmp(hostname,buf,strlen(hostname)) == 0) 
             {
               i = 0;
               while ((buf[i] != '\0') && (buf[i] != '_')) i++;
               i=i+2;
               j=0;
               while ((buf[i] != '\0') && (buf[i] != '_'))
                  {
                   numberarr[j] = buf[i]; i++; j++;
                  }
               numberarr[j] = '\0';
               num[k++] = atoi(numberarr);             
             }
         }
        UINcreatehostname(kindmess,hostname,num);  
*/        
 }
 

/* -----------------------------------------------------------------------
 *  Function:  	UINgetmaxmessage  
 *  Argument:   maxmessage, specifies maximum messagesize (OUT). 
 *  Purpose:   	This function asks the user for an maximum messagesize.
 *  Remarks:   	Default messagesize is 484.
 * -----------------------------------------------------------------------
*/
void UINgetmaxmessage (maxmessage)
   char *maxmessage;
{   
  int  maxmessint;

   fflush(stdin);
   do
    {
     fprintf(stdout,"\t4) Maximum messagesize [484-65507,484]: " );
     fflush(stdin);
     do {
      maxmessint = UINgetint();
      if (maxmessint == -1) {
	fprintf( stdout, "\t\tERROR: invalid messagesize.\n" );
        fprintf(stdout,"\t4) Maximum messagesize [484-65507,484]: " );
      }
      fflush( stdin );
     } while (maxmessint == -1);
     if (maxmessint == 0)  maxmessint = 484;
     if( (maxmessint < 484) || (maxmessint > 65507) )
	fprintf( stdout, "\t\tERROR: messagesize not within range.\n" );
    }
   while ((maxmessint < 484) || (maxmessint > 65507));
   sprintf(maxmessage,"%d",maxmessint); 
   fflush(stdin);
}



/* -----------------------------------------------------------------------
 *  Function:  	Gettaddress 
 *  Arguments:  kindmess (IN)
 *              taddress, specifies agent portnumber (OUT) 
 *  Purpose:   	This function asks to the user to specify an portnumber 
 *		within the given range.
 *  Remarks:   	Default portnumber is 161 or 162.
 * -----------------------------------------------------------------------
*/
void UINgettaddress (kindmess,taddress)
   int   kindmess;
   char *taddress;
{
   int taddressint = -1;
   
   fflush( stdin );
   do {
     switch (kindmess) {
       case 0: fprintf( stdout, 
			 "\t3) Portnumber for manager application [0-65536,162]: " );
    	      	break;
       case 1:	fprintf( stdout, 
			 "\t3) Portnumber for agent application [0-65536,161]: " );
     }
     fflush(stdin);
     do{
      taddressint = UINgetint();
      if (taddressint == -1) { 
		fprintf( stdout, "\t\tERROR: invalid portnumber.\n" );
     		switch (kindmess) {
       		case 0: fprintf( stdout, 
			 "\t3) Portnumber for manager application [0-65536,162]: " );
    	      		break;
       		case 1:	fprintf( stdout, 
			 "\t3) Portnumber for agent application [0-65536,161]: " );
     		}
		fflush( stdin );
      }
     } while (taddressint == -1);
     switch (kindmess)
       {
       case 0:
              if (taddressint == 0) 
		taddressint = 162;
    	      break;
       case 1:
   	      if (taddressint == 0) 
		taddressint = 161;
       }
     if( (taddressint < 0 ) || (taddressint > 65536) ) {
     fprintf( stdout, "\t\tERROR: portnumber not within range.\n" );
       } else
           sprintf(taddress,"%d",taddressint);
     } while ((taddressint < 0) || (taddressint > 65536));
   }


/* -----------------------------------------------------------------------
 *  Function:  	UINintro
 *  Arguments:	hostnameM, hostname for management application (OUT).
 *		ipaddressM, internet address for management application (OUT).
 *		hostnameA, hostname for agent application (OUT).
 *		ipaddressA, internet address for agent application (OUT).
 *		maxmessage, specifies maximum message size (OUT).
 *		taddress, specifies port number for agent application (OUT).
 *  Purpose:   	This function  displays the intro screen and asks the user 
 *		for additional information. (see arguments)
 *  Remarks:
 * -----------------------------------------------------------------------
*/
void UINintro(hostnameM,ipaddressM,hostnameA,ipaddressA,maxmessage,taddressM,taddressA)
    char *hostnameM,*ipaddressM,*hostnameA,*ipaddressA,*maxmessage,*taddressM,*taddressA;
{  

     system( "clear" );
     fprintf( stdout,
	"\n ************************************************************************\n");
     fprintf( stdout, " *\t\t\t\t\t\t\t\t\t*\n" );
     fprintf( stdout, " * ut-initagent (version %s)\t\t\t\t\t*\n", VERSION );
     fprintf( stdout, " * ------------\t\t\t\t\t\t\t*\n" );
     fprintf( stdout, " *\t\t\t\t\t\t\t\t\t*\n" );
     fprintf( stdout, 
	" * This program creates initial partymib *.conf-files for applications,\t*\n" );
     fprintf( stdout, 
	" * acting in the agent role, belonging to the cmu-snmp-v2.1 or \t\t*\n" );
     fprintf( stdout, " * UT-SNMP packages.\t\t\t\t\t\t\t*\n");
     fprintf( stdout, " *\t\t\t\t\t\t\t\t\t*\n" );
     fprintf( stdout, " *\t\t\t\t\tSuccess, \t\t\t*\n" );
     fprintf( stdout, " *\t\t\t\t\t\tsnmp@cs.utwente.nl\t*\n" );
     fprintf( stdout, " *\t\t\t\t\t\t\t\t\t*\n" );
     fprintf( stdout, " * Additional remark:\t\t\t\t\t\t\t*\n");
     fprintf( stdout, " *\t%% setenv SNMP_PARTYMIB_PATH ./ \t\t# path for partyfiles\t*\n");
     fprintf( stdout, " *\t%% setenv SNMP_PARTYMIB_INITPATH ./etc/\t# path to init-files\t*\n");
     fprintf( stdout, " *\t\t\t\t\t\t\t\t\t*\n" );
     fprintf( stdout,
	" ************************************************************************\n\n");
     fprintf( stdout, " Specify user-definable data:\n\n" );
     UINipaddresshostname(0,ipaddressM,hostnameM);
     UINipaddresshostname(1,ipaddressA,hostnameA);
     UINgettaddress (0,taddressM);
     UINgettaddress (1,taddressA);
     UINgetmaxmessage (maxmessage);
}


 
/* -----------------------------------------------------------------------
 *  Function:  partyuser
 *  Arguments: kindmess, string (IN)
	       hostnameM, string (IN)
	       mname, string (OUT)
	       hostnameA, string (IN)
	       aname , string (OUT)
 *  Purpose:   User interface to fill parties with user-defined values
 *  Remarks:   KindMess=0: NoAuth/NoPriv party message on screen
 *             KindMess=1: Auth/NoPriv party message on screen
 *             KindMess=2: Auth/Priv party message on screen
 * -----------------------------------------------------------------------
*/
int UINpartyuser(kindmess,mname,hostnameA,aname)
   int kindmess;
   char *mname,*hostnameA,*aname;
{
     static int init = 0;

     if( init == 0 ) {
     	fprintf( stdout, "\tCreating p[arty],v[iew],a[cl],c[ontext] " );	
	init = 1;
     }
     switch (kindmess)
     {
      case 0: /* fprintf( stdout," noAuth/noPriv parties " ); */
              strcpy (aname,"agentNoAuthNoPriv_");
              strncpy(aname+18,hostnameA,10);
              strcpy (mname,"managerNoAuthNoPriv_");
              strncpy(mname+20,hostnameA,10);
              break;
      case 1: /* fprintf( stdout," md5Auth/noPriv parties " ); */
              strcpy (aname,"agentV2md5NoPriv_");
              strncpy(aname+17,hostnameA,10);
              strcpy (mname,"managerV2md5NoPriv_");
              strncpy(mname+19,hostnameA,10);
              break;
      case 2: /* fprintf( stdout, " md5Auth/desPriv parties.\n" );*/
              strcpy (aname,"agentV2md5DesPriv_");
              strncpy(aname+18,hostnameA,10);
              strcpy (mname,"managerV2md5DesPriv_");
              strncpy(mname+20,hostnameA,10);
              break;
      default: fprintf( stdout, "\t\tERROR: Not a correct kindmess number\n"); 
	      return(-1);
	      break;  
    }
     return(0);
}



/* -----------------------------------------------------------------------
 *  Function:  contextuser
 *  Arguments: KindMess, (IN)
	       Cname (OUT)
	       hostnameA (IN)
 *  Purpose:   User interface to fill context with user-defined values
 *  Remarks:   KindMess=0: necesarry Contextentry if you use NoAuth/NoPriv parties
 *             KindMess=1: necesarry ContextEntry if you use Auth/NoPriv or Auth/Priv parties
 * -----------------------------------------------------------------------
*/
int UINcontextuser(kindmess,cname,hostnameA)
   char *cname,*hostnameA;
   int kindmess;
  { 
    switch(kindmess)
     {
       case 0: 
               strcpy (cname,"context1_");
               break;
       case 1:
               strcpy (cname,"context2_");
               break;
       default: fprintf (stdout,"\t\tERROR: not a correct kindmess number\n");
	       return(-1); 
	       break; 
     }
     strncpy(cname+9,hostnameA,10);
     return(0);
  }
 
