/* -----------------------------------------------------------------------------
 * project:	UT-SNMP
 * file:	snmpInitPerkins.h
 * date:	22 September 1994
 * purpose:	initialisation defenitions as proposed by David Perkins
 * author(s):	edited by Martijn Visser
 * -----------------------------------------------------------------------------
 */

#ifndef	SNMPINITAGENT_H
#define	SNMPINITAGENT_H

#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/time.h>

/* 
 *	Type and macro definitions.
 */
#define MAXRECSTR 100 
#define ARLEN 100 
#define MAXSTRLEN 40
#define BUFSIZE 512
#define MAXAPPL 100
#define FILELEN 100
#define FILENAMELEN 100
#define HOSTNAMELEN 100
#define INTARRLEN 32
#define lengthEntry 100

typedef int	INTEGER;	/* local integer representation, int: 32 bits */
extern int errno;

/*
 *	The SNMPV2 party database group related structures
 */
typedef struct {
        char 		partyName[MAXRECSTR];
        char  		partyIdentity[MAXRECSTR]; 	
	INTEGER		partyIndex;		/* position in the partyTable */
	char		partyTDomain[MAXRECSTR];
	char		partyTAddress[MAXRECSTR];
	char		partyMaxMessageSize[MAXRECSTR];
	char		partyLocal[MAXRECSTR]; 			/* own or remote party */
	char		partyAuthProtocol[MAXRECSTR];
	char		partyAuthClock[MAXRECSTR];
	char		partyAuthPrivate[MAXRECSTR];
	char		partyAuthPublic[MAXRECSTR];
	char 	 	partyAuthLifetime[MAXRECSTR];
	char		partyPrivProtocol[MAXRECSTR];
	char		partyPrivPrivate[MAXRECSTR];
	char		partyPrivPublic[MAXRECSTR];
	
	char		IPaddress[MAXRECSTR];
	INTEGER		partyType;
	
} partyEntry;

typedef struct {
        char 		contextName[MAXRECSTR];
        char		contextIdentity[MAXRECSTR];
  	INTEGER		contextIndex;	/* position in the contextTable */
	char 		contextLocal;	/* objects on this or remote system */
	INTEGER		contextViewIndex; /* could be a union structure */
	char		contextLocalEntity[MAXRECSTR];
	char		contextLocalTime[MAXRECSTR];
	char		contextProxyDstParty[MAXRECSTR];
	char		contextProxySrcParty[MAXRECSTR];
	char		contextProxyContext[MAXRECSTR];
} contextEntry;

typedef struct {
	char		aclName[MAXRECSTR];
	INTEGER		aclTarget;
	INTEGER		aclSubject;
	INTEGER		aclResources;
	char		aclPrivileges[MAXRECSTR];
} aclEntry;

typedef struct {
	char		aclName[MAXRECSTR];
	char		viewName[MAXRECSTR];
	int		viewIndex;
	char   		viewSubtree[MAXRECSTR];
	char 		viewMask[MAXRECSTR];
	char		viewType[MAXRECSTR];
} viewEntry;


#ifdef MAIN


char InitialPartyId[] = "initialPartyId.";
char InitialContextId[] = "initialContextId.";

char AgentFile[] = "_agent.perkins.conf";
char AgentHeader[] = "agent.perkins.ini";

#else

extern char InitialPartyId[];
extern char InitialContextId[];
extern char AgentFile[];
extern char AgentHeader[];

#endif

extern int UINcontextuser( int kindmess, char *cname, char *hostnameA );
extern void UINintro( char *hostnameM, char *ipaddressM, char *hostnameA,
	    	      char *ipaddressA, char *maxmessage, char *taddressM,
		      char *taddressA );
extern int UINpartyuser( int kindmess, char *mname, char *hostnameA,
			char *aname );
extern void SINgetrandomkey( char *randomkey );

#endif	/* SNMPINITAGENT_H */


