/* -----------------------------------------------------------------------
 *
 * Project:	UT-SNMP
 *
 * Filename:    snmpv2_per.c
 *
 * Date:        May 1994.
 *
 * Purpose:     Interface to PER modules.
 *
 * Author(s):   Rene Oude Vrielink
 *
 * -----------------------------------------------------------------------
 */
/*
 *    snmpv2_per.c
 *
 *    "SNMPv2-MESS" ASN.1 module encode/decode/print/free C src.
 *
 *    This file was generated by snacc on Mon Feb 28 13:08:38 1994
 *
 *    UBC snacc written by Mike Sample
 *
 *    NOTE: This is a machine generated file - editing not recommended
 */


#include <snmpTypes.h>
#include <snacc/asn_config.h>
#include <perv2/per_buf.h>
#include <perv2/per_bits.h>
#include <perv2/per_int.h>
#include <perv2/per_len.h>
#include <perv2/per_octs.h>
#include <perv2/per_oid.h>
#include <perv2/snmpv2_per.h>

/*
 * 	these oids are moved to snmpConst.h and assigned
 * 	in spmMisc.c
 *
AsnInt max_bindings = 2147483647;
AsnOid internet = { 3, "\53\6\1" };
AsnOid directory = { 4, "\53\6\1\1" };
AsnOid mgmt = { 4, "\53\6\1\2" };
AsnOid experimental = { 4, "\53\6\1\3" };
AsnOid private = { 4, "\53\6\1\4" };
AsnOid enterprises = { 5, "\53\6\1\4\1" };
AsnOid security = { 4, "\53\6\1\5" };
AsnOid snmpV2 = { 4, "\53\6\1\6" };
AsnOid snmpDomains = { 5, "\53\6\1\6\1" };
AsnOid snmpProxys = { 5, "\53\6\1\6\2" };
AsnOid snmpModules = { 5, "\53\6\1\6\3" };
 * 
 */





AsnLen
PerEncSnmpMgmtComChoice(BUF_TYPE b, SnmpMgmtComChoice* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    switch(v->choiceId)
    {
       case(SNMPMGMTCOMCHOICE_GET_REQUEST):
    
    itemLen = v->a.get_request->octetLen;
    totalLen += itemLen;

    break;

       case(SNMPMGMTCOMCHOICE_GET_NEXT_REQUEST):
   
    itemLen = v->a.get_next_request->octetLen;
    totalLen += itemLen;

    break;

       case(SNMPMGMTCOMCHOICE_RESPONSE):
    
    itemLen = v->a.response->octetLen;
    totalLen += itemLen;

    break;

       case(SNMPMGMTCOMCHOICE_SET_REQUEST):
    
    itemLen = v->a.set_request->octetLen;
    totalLen += itemLen;

    break;

       case(SNMPMGMTCOMCHOICE_GET_BULK_REQUEST):
    
    itemLen = v->a.get_bulk_request->octetLen;
    totalLen += itemLen;

    break;

       case(SNMPMGMTCOMCHOICE_INFORM_REQUEST):
    
    itemLen = v->a.inform_request->octetLen;
    totalLen += itemLen;

    break;

       case(SNMPMGMTCOMCHOICE_SNMPV2_TRAP):
    
    itemLen = v->a.snmpV2_trap->octetLen; 
    totalLen += itemLen;

    break;

    }
    return (totalLen);

}  /* PerEncSnmpMgmtComChoice */

	STATUS
PerDecSnmpMgmtComChoice(BUF_TYPE b, SnmpMgmtComChoice* v, AsnLen totalLen) 
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtVal;

 
    PerDecLenCons(b, &elmtVal, 5);
    totalElmtsLen++;
    
    switch(elmtVal)
    {
	case(0):
	(v->choiceId) = SNMPMGMTCOMCHOICE_GET_REQUEST;
    (v->a.get_request) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    v->a.get_request->octs = *b;
    v->a.get_request->octetLen = (totalLen - totalElmtsLen);

    break;

       case(1):
        (v->choiceId) = SNMPMGMTCOMCHOICE_GET_NEXT_REQUEST;
    (v->a.get_next_request) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    v->a.get_next_request->octs = *b;
    v->a.get_next_request->octetLen = (totalLen - totalElmtsLen);
   
  
    break;

       case(2):
        (v->choiceId) = SNMPMGMTCOMCHOICE_RESPONSE;
    (v->a.response) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    v->a.response->octs = *b;
    v->a.response->octetLen = (totalLen - totalElmtsLen);
   
    break;

       case(3):
        (v->choiceId) = SNMPMGMTCOMCHOICE_SET_REQUEST;
    (v->a.set_request) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    v->a.set_request->octs =  *b;
    v->a.set_request->octetLen = (totalLen - totalElmtsLen);
   
    break;

       case(4):
        (v->choiceId) = SNMPMGMTCOMCHOICE_GET_BULK_REQUEST;
    (v->a.get_bulk_request) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    v->a.get_bulk_request->octs = *b;
    v->a.get_bulk_request->octetLen = (totalLen - totalElmtsLen);
   
    break;

       case(5):
        (v->choiceId) = SNMPMGMTCOMCHOICE_INFORM_REQUEST;
    (v->a.inform_request) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    v->a.inform_request->octs = *b;
    v->a.inform_request->octetLen = (totalLen - totalElmtsLen);
   
    break;

       case(6):
        (v->choiceId) = SNMPMGMTCOMCHOICE_SNMPV2_TRAP;
    (v->a.snmpV2_trap) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    v->a.snmpV2_trap->octs = *b;
    v->a.snmpV2_trap->octetLen = (totalLen - totalElmtsLen);
   
    break;

    default:
        Asn1Error("ERROR - unexpected PER tag in CHOICE\n");
        break;
    } 
    return( OK );
}  /* PerDecSnmpMgmtComChoice */



AsnLen
PerEncSnmpAuthMsgChoiceSeq( BUF_TYPE b, SnmpAuthMsgChoiceSeq* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;

    itemLen = PerEncUInt(b, (&v->authSrcTimestamp));
    itemLen += PerEncLenDeter( b, &itemLen, 1);

    totalLen += itemLen;

    itemLen = PerEncUInt(b, (&v->authDstTimestamp));
    itemLen += PerEncLenDeter( b, &itemLen, 1);

    totalLen += itemLen;

    itemLen = PerEncOcts( b, (&v->authDigest));
	/*
	 * NO length field because authDigest is always 16 :)
	 *
	 */

    totalLen += itemLen;

    return (totalLen);

}  /* PerEncSnmpAuthMsgChoiceSeq */

AsnLen
PerDecSnmpAuthMsgChoiceSeq(BUF_TYPE b, SnmpAuthMsgChoiceSeq* v)
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;

    PerDecOcts( b, (&v->authDigest), 16);
    totalElmtsLen += 16;

    totalElmtsLen += PerDecLenDeter(b, &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecUInt(b, (&v->authDstTimestamp), elmtLen);

    totalElmtsLen += PerDecLenDeter(b, &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecUInt(b, (&v->authSrcTimestamp), elmtLen);

    return(totalElmtsLen);
}  /* PerDecSnmpAuthMsgChoiceSeq */


AsnLen
PerEncSnmpAuthMsgChoice (BUF_TYPE b, SnmpAuthMsgChoice* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;

    switch(v->choiceId)
    {
       case(SNMPAUTHMSGCHOICE_NOAUTH):
    /*
     * noAuth is SIZE(0) so nothing to be done!!! 
     * Only a one byte field has to be added 
     * to make difference between CHOICE ---> noAuth is zero
     */

    PerEncLenCons(b, 0, 7);
    totalLen += 1;

       break;

       case(SNMPAUTHMSGCHOICE_V2MD5AUTHPROTOCOL):
    
    itemLen = PerEncSnmpAuthMsgChoiceSeq ( b, (v->a.v2md5AuthProtocol));
    totalLen += itemLen;
    PerEncLenCons(b, 1, 7);
    totalLen += 1;

       break;

    }
    return (totalLen);

}  /* PerEncSnmpAuthMsgChoice */

AsnLen
PerDecSnmpAuthMsgChoice(BUF_TYPE b,SnmpAuthMsgChoice* v) 
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtVal;

    PerDecLenCons(b, &elmtVal, 7);
    totalElmtsLen++;

    switch(elmtVal)
    {
      case(0):
     	(v->choiceId) = SNMPAUTHMSGCHOICE_NOAUTH;
     	(v->a.noAuth) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
        (v->a.noAuth->octetLen) = 0;

      break;

      case(1):
        (v->choiceId) = SNMPAUTHMSGCHOICE_V2MD5AUTHPROTOCOL;
    	(v->a.v2md5AuthProtocol) = (SnmpAuthMsgChoiceSeq*) Asn1Alloc(sizeof(SnmpAuthMsgChoiceSeq));
    	totalElmtsLen += PerDecSnmpAuthMsgChoiceSeq( b,(v->a.v2md5AuthProtocol));
      break;

      default:
        Asn1Error("ERROR - unexpected PER field in CHOICE\n");
        return( ERROR );
      break;
    } /* end switch */
    return(totalElmtsLen);
}  /* PerDecSnmpAuthMsgChoice */


AsnLen
PerEncObjectSyntax(BUF_TYPE b, ObjectSyntax* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen = 0;
    AsnLen bitLen = 0;
    UAsnInt applByte;

    applByte = 8; /* 0000 1000 b needed for application choice */

    switch(v->choiceId)
    {
       case(OBJECTSYNTAX_INTEGER_VALUE):
    itemLen = PerEncInt( b, (&v->a.integer_value));
    itemLen += PerEncLenDeter(b, &itemLen, 1);
    PerEncLenCons(b, 0, 2);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For integer_value this value is 0000 0000 b.
     */
     itemLen++;

     totalLen += itemLen;

    break;
       
       case(OBJECTSYNTAX_BIT_VALUE):
    bitLen = PerEncBits( b, (v->a.bit_value));
    itemLen = ((bitLen-1)/8) + 1;
    itemLen += PerEncLenDeter( b, &bitLen, 2);
    PerEncLenCons(b, 1, 2);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For bit_value this value is 0000 0100 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(OBJECTSYNTAX_STRING_VALUE):
    itemLen = PerEncOcts( b, (v->a.string_value));
    itemLen += PerEncLenDeter( b, &itemLen, 1);
    /* FRAGMENTATION MAY BE THERE !!!!*/
    PerEncLenCons(b, 2, 2);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For string_value this value is 0000 1000 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(OBJECTSYNTAX_OBJECTID_VALUE):
    itemLen = PerEncOid( b, (v->a.objectID_value));
    itemLen += PerEncLenDeter( b, &itemLen, 1);
    PerEncLenCons(b, 3, 2);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For objectID_value this value is 0000 1100 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;


       case(OBJECTSYNTAX_IPADDRESS_VALUE):
    itemLen = PerEncOcts( b, (v->a.ipAddress_value));
	/* 
	 * NO length field needed SIZE is always 4
	 */
    PerEncLenCons(b, (applByte | 0), 1);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For ipAddress_value this value is 0001 0000 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(OBJECTSYNTAX_COUNTER_VALUE):
    itemLen = PerEncUInt( b, (&v->a.counter_value));
    itemLen += PerEncLenDeter( b, &itemLen, 1);
    PerEncLenCons(b, (applByte | 1), 1);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For counter_value this value is 0001 0010 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(OBJECTSYNTAX_GAUGE_VALUE):
    itemLen = PerEncUInt( b, (&v->a.gauge_value));
    itemLen += PerEncLenDeter( b, &itemLen, 1);
    PerEncLenCons(b, (applByte | 2), 1);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For gauge_value this value is 0001 0100 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(OBJECTSYNTAX_TIMETICKS_VALUE):
    itemLen = PerEncUInt( b, (&v->a.timeticks_value));
    itemLen += PerEncLenDeter( b, &itemLen, 1);
    PerEncLenCons(b, (applByte | 3), 1);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For timeticks_value this value is 0001 0110 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(OBJECTSYNTAX_ARBITRARY_VALUE):
    itemLen = PerEncOcts( b, (v->a.arbitrary_value));
    itemLen += PerEncLenDeter( b, &itemLen, 1);
    /* FRAGMENTATION !!!*/
    PerEncLenCons(b, (applByte | 4), 1);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For arbitrary_value this value is 0001 1000 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(OBJECTSYNTAX_NSAPADDRESS_VALUE):
    itemLen = PerEncOcts( b, (v->a.nsapAddress_value));
    PerEncLenAddr(b, (applByte | 5), itemLen);
    /* This is a function only used here.
     * it makes place for 16 bits. 
     * The first 7 bits reflect the choice
     * the following 5 bits reflect the length value
     * 
     * For nsapAddress_value the first 7 bits are  0001 101 b.
     */
    itemLen += 2;

    totalLen += itemLen;

    break;

       case(OBJECTSYNTAX_BIG_COUNTER_VALUE):
    itemLen = PerEncUInt(b, (&v->a.big_counter_value));
    itemLen += PerEncLenDeter( b, &itemLen, 1);
    PerEncLenCons(b, (applByte | 6), 1);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For big_counter_value this value is 0001 1100 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(OBJECTSYNTAX_UNSIGNED_INTEGER_VALUE):
    itemLen = PerEncUInt( b, (&v->a.unsigned_integer_value));
    itemLen += PerEncLenDeter( b, &itemLen, 1);
    PerEncLenCons(b, (applByte | 7), 1);
    /* Two fields are prepended.
     * One shows the length of the value
     * The last shows the value of the CHOICE
     * For unsigned_integer_value THIS VALUE IS 0001 1110 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

    }
    return (totalLen);

}  /* PerEncObjectSyntax */


	STATUS
PerDecObjectSyntax(BUF_TYPE b,ObjectSyntax* v) 
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;
    UAsnInt applByte;
    UAsnInt elmtVal;
    UAsnInt simpleVal;
    UAsnInt applVal;

    applByte = 8; /* 0000 1000 b needed for application choice */

   
    PerPeekLenCons(b, &elmtVal, 4);
    
    switch(elmtVal)
    {
       case(0):

       PerDecLenCons(b, &simpleVal, 2);
       switch(simpleVal)
       {
	  case(0):
           (v->choiceId) = OBJECTSYNTAX_INTEGER_VALUE;
           PerDecLenDeter(b, &elmtLen, 1);
	   PerDecInt(b, (&v->a.integer_value), elmtLen);
          break;
       	  
	  case(1):
           (v->choiceId) = OBJECTSYNTAX_BIT_VALUE;
           PerDecLenDeter( b, &elmtLen, 2);
	   (v->a.bit_value) = (AsnBits*) Asn1Alloc(sizeof(AsnBits));
    	   PerDecBits( b, (v->a.bit_value), elmtLen);
    	  break;

          case(2):
           (v->choiceId) = OBJECTSYNTAX_STRING_VALUE;
           PerDecLenDeter( b, &elmtLen, 1);
	   (v->a.string_value) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    	   PerDecOcts( b, (v->a.string_value), elmtLen);
    	  break;

          case(3):
           (v->choiceId) = OBJECTSYNTAX_OBJECTID_VALUE;
    	   PerDecLenDeter( b, &elmtLen, 1);
	   (v->a.objectID_value) = (AsnOid*) Asn1Alloc(sizeof(AsnOid));
    	   PerDecOid( b, (v->a.objectID_value), elmtLen);
    	  break;
          
	  default:
            Asn1Error("ERROR - unexpected PER simple syntax CHOICE\n");
          break;
       } /* end switch */
       break;
       
       case(1): /* application wide tagging in this case */
       
       PerPeekLenCons(b, &applVal, 1);
       applVal &= ~(applByte);
       
       switch(applVal)
       {
          case(0):
           (v->choiceId) = OBJECTSYNTAX_IPADDRESS_VALUE;
    	   (v->a.ipAddress_value) = (IpAddress*) Asn1Alloc(sizeof(IpAddress));
           PerDecLenCons(b, &applVal, 1);
    	   PerDecOcts( b, (v->a.ipAddress_value), 4);
    	   /* length is 4!!! always */
	  break;

          case(1):
           (v->choiceId) = OBJECTSYNTAX_COUNTER_VALUE;
           PerDecLenCons(b, &applVal, 1);
    	   PerDecLenDeter( b, &elmtLen, 1);
	   PerDecUInt( b, (&v->a.counter_value), elmtLen);
    	  break;

       	  case(2):
           (v->choiceId) = OBJECTSYNTAX_GAUGE_VALUE;
           PerDecLenCons(b, &applVal, 1);
    	   PerDecLenDeter( b, &elmtLen, 1);
	   PerDecUInt( b, (&v->a.gauge_value), elmtLen);
          break;

          case(3):
           (v->choiceId) = OBJECTSYNTAX_TIMETICKS_VALUE;
           PerDecLenCons(b, &applVal, 1);
    	   PerDecLenDeter( b, &elmtLen, 1);
	   PerDecUInt( b, (&v->a.timeticks_value), elmtLen);
          break;

          case(4):
           (v->choiceId) = OBJECTSYNTAX_ARBITRARY_VALUE;
    	   (v->a.arbitrary_value) = (Opaque*) Asn1Alloc(sizeof(Opaque));
           PerDecLenCons(b, &applVal, 1);
    	   PerDecLenDeter( b, &elmtLen, 1);
    	   PerDecOcts( b, (v->a.arbitrary_value), elmtLen);
          break;
       
	  case(5):
           (v->choiceId) = OBJECTSYNTAX_NSAPADDRESS_VALUE;
           (v->a.nsapAddress_value) = (NsapAddress*) Asn1Alloc(sizeof(NsapAddress));
    	   PerDecLenAddr( b, &applVal, &elmtLen); 
	   PerDecOcts(b, (v->a.nsapAddress_value), elmtLen);
          break;

       	  case(6):
           (v->choiceId) = OBJECTSYNTAX_BIG_COUNTER_VALUE;
           PerDecLenCons(b, &applVal, 1);
    	   PerDecLenDeter( b, &elmtLen, 1);
	   PerDecUInt( b, (&v->a.big_counter_value), elmtLen);
          break;

          case(7):
           (v->choiceId) = OBJECTSYNTAX_UNSIGNED_INTEGER_VALUE;
           PerDecLenCons(b, &applVal, 1);
    	   PerDecLenDeter( b, &elmtLen, 1);
	   PerDecUInt( b, (&v->a.unsigned_integer_value), elmtLen);
          break;

          default:
            Asn1Error("ERROR - unexpected PER application CHOICE\n");
          break;
       } /*  end switch */
       break;
       
       default:
            Asn1Error("ERROR - unexpected PER simple & appl CHOICE\n");
       break;
    } /*  end switch */  
}   /*  PerDecObjectSyntax */





AsnLen
PerEncVarBindChoice(BUF_TYPE b, VarBindChoice* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen = 0;

    switch(v->choiceId)
    {
       case(VARBINDCHOICE_VALUE):
    itemLen = PerEncObjectSyntax( b, (v->a.value));

    totalLen += itemLen;

    break;

       case(VARBINDCHOICE_UNSPECIFIED):
    PerEncLenCons( b, 1, 5);
    /*
     * The length field shows the CHOICE in Varbind
     * For unSpecified this value is 0010 0000 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(VARBINDCHOICE_NOSUCHOBJECT):
    PerEncLenCons( b, 2, 5);
    /*
     * The length field shows the CHOICE in Varbind
     * For noSuchObject this value is 0100 0000 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(VARBINDCHOICE_NOSUCHINSTANCE):
    PerEncLenCons( b, 3, 5);
    /*
     * The length field shows the CHOICE in Varbind
     * For noSuchInstance this value is 0110 0000 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(VARBINDCHOICE_ENDOFMIBVIEW):
    PerEncLenCons( b, 4, 5);
    /*
     * The length field shows the CHOICE in Varbind
     * For endOfMibView this value is 1000 0000 b.
     */
    itemLen++;

    totalLen += itemLen;

    break;

    }
    return (totalLen);

}  /* PerEncVarBindChoice */


void
PerDecVarBindChoice(BUF_TYPE b, VarBindChoice* v)
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;
    UAsnInt elmtVal = 0;

    PerPeekLenCons(b, &elmtVal, 5);
    
    switch(elmtVal)
    {
       case(0):
        (v->choiceId) = VARBINDCHOICE_VALUE;
    (v->a.value) = (ObjectSyntax*) Asn1Alloc(sizeof(ObjectSyntax));
    PerDecObjectSyntax( b, (v->a.value));
    break;

       case(1):
        (v->choiceId) = VARBINDCHOICE_UNSPECIFIED;
        PerDecLenCons(b, &elmtVal, 5);
    	/* b will be shifted 1 byte !!!!!!!*/
    break;

       case(2):
        (v->choiceId) = VARBINDCHOICE_NOSUCHOBJECT;
        PerDecLenCons(b, &elmtVal, 5);
    break;

       case(3):
        (v->choiceId) = VARBINDCHOICE_NOSUCHINSTANCE;
        PerDecLenCons(b, &elmtVal, 5);
    break;

       case(4):
        (v->choiceId) = VARBINDCHOICE_ENDOFMIBVIEW;
        PerDecLenCons(b, &elmtVal, 5);
    break;

    default:
        Asn1Error("ERROR - unexpected PER varbind CHOICE\n");
        break;
    }
} /*  PerDecVarBindChoice */


AsnLen
PerEncVarBind(BUF_TYPE b, VarBind* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;

    itemLen = PerEncVarBindChoice( b, (v->varBindChoice));

    totalLen += itemLen;

    itemLen = PerEncOid( b, (&v->name));
    itemLen += PerEncLenDeter( b, &itemLen, 1);

    totalLen += itemLen;

    return (totalLen);

}  /* PerEncVarBind */


	STATUS
PerDecVarBind(BUF_TYPE b, VarBind* v)
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;


    totalElmtsLen = PerDecLenDeter(b , &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecOid( b, (&v->name), elmtLen);


    (v->varBindChoice) = (VarBindChoice*) Asn1Alloc(sizeof(VarBindChoice));
    PerDecVarBindChoice( b, (v->varBindChoice));
}   /* PerDecVarBind */


AsnLen
PerEncVarBindList(BUF_TYPE b, VarBindList* v, AsnLen *listLen)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    void* component;

        *listLen = 0;
    FOR_EACH_LIST_ELMT_RVS( component, v)
    {
    itemLen = PerEncVarBind( b, component);

	totalLen += itemLen;
        (*listLen)++;
    }
    return (totalLen);

}  /* PerEncVarBindList */


	STATUS
PerDecVarBindList(BUF_TYPE b, VarBindList* v, AsnLen listLen) 
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;


    for ( totalElmtsLen = 0; (totalElmtsLen < listLen); totalElmtsLen++)
    {
        VarBind** tmpVar;
    
    tmpVar = (VarBind**) AsnListAppend(v);
    (*tmpVar) = (VarBind*) Asn1Alloc(sizeof(VarBind));
    PerDecVarBind(b, (*tmpVar));
    }  

    return( OK ); 
}   /* PerDecVarBindList */


AsnLen
PerEncPDU( BUF_TYPE b, PDU* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    itemLen = PerEncVarBindList( b, (v->variable_bindings), &listLen);
    /* 
     * this length field shows the number of
     * variable bindings !!!!!
     */
    itemLen += PerEncLenDeter( b, &listLen, 1);

    totalLen += itemLen;

    itemLen = PerEncUInt( b, (&v->error_index));
    itemLen += PerEncLenDeter( b, &itemLen, 1);

    totalLen += itemLen;

    PerEncLenCons( b, v->error_status, 3);
    /* shift of 3 because range of error_status is 19 */
    itemLen = 1;

    totalLen += itemLen;

    itemLen = PerEncInt( b, (&v->request_id));
    itemLen += PerEncLenDeter( b, &itemLen, 1);

    totalLen += itemLen;

    return (totalLen);

}  /* PerEncPDU */

	STATUS
PerDecPDU(BUF_TYPE b, PDU* v)
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;
    AsnLen listLen;


    totalElmtsLen += PerDecLenDeter (b, &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecInt(b, (&v->request_id), elmtLen);
    
    PerDecLenCons (b, (&v->error_status), 3);
    /* shift of 3 because range of error_status is 19 */
    totalElmtsLen++;

    totalElmtsLen += PerDecLenDeter (b, &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecUInt(b, (&v->error_index), elmtLen);

    totalElmtsLen += PerDecLenDeter (b, &listLen, 1);
    
    (v->variable_bindings) = AsnListNew(sizeof(char*));
    PerDecVarBindList( b, (v->variable_bindings), listLen);
    return( OK );
}   /* PerDecPDU */


AsnLen
PerEncBulkPDU(BUF_TYPE b, BulkPDU* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    itemLen = PerEncVarBindList( b, (v->variable_bindings), &listLen);
    itemLen += PerEncLenDeter( b, &listLen, 1);

    totalLen += itemLen;

    itemLen = PerEncUInt( b, (&v->max_repetitions));
    itemLen += PerEncLenDeter(b , &itemLen, 1);

    totalLen += itemLen;

    itemLen = PerEncUInt( b, (&v->non_repeaters));
    itemLen += PerEncLenDeter(b , &itemLen, 1);

    totalLen += itemLen;

    itemLen = PerEncInt( b, (&v->request_id));
    itemLen += PerEncLenDeter(b , &itemLen, 1); 

    totalLen += itemLen;

    return (totalLen);

}  /* PerEncBulkPDU */


	STATUS
PerDecBulkPDU(BUF_TYPE b,BulkPDU* v)
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;
    AsnLen listLen;


    totalElmtsLen += PerDecLenDeter (b, &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecInt(b, (&v->request_id), elmtLen);


   
    totalElmtsLen += PerDecLenDeter (b, &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecUInt(b, (&v->non_repeaters), elmtLen);
	   

    totalElmtsLen += PerDecLenDeter (b, &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecUInt(b, (&v->max_repetitions), elmtLen);


    totalElmtsLen += PerDecLenDeter (b, &listLen, 1);
    (v->variable_bindings) = AsnListNew(sizeof(char*));
    PerDecVarBindList( b, (v->variable_bindings), listLen);
    return( OK );

}   /* PerDecBulkPDU */



AsnLen
PerEncSnmpPrivMsg (BUF_TYPE b, SnmpPrivMsg* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen fragLen1, fragLen2;
    AsnLen listLen;
    void* component;
    char* fragment;
    char*	bsave1;
    char*	bsave2;

    itemLen = v->privData.octetLen;
    /*PerEncOcts ( b, (&v->privData));*/
    fragLen1 = PerEncLenDeter( b, &itemLen, 1);
   
    bsave1 = *b;
    if (fragLen1 == 3)
    {
    fragLen2 = v->privData.octetLen - itemLen;
    /* copy the fragment into a seperate location */
    fragment = (char *) malloc(itemLen);
    PerSkip(b,fragLen2 + 1);
    bsave2 = *b;
    PerCopy(fragment, b, itemLen);
    *b = bsave2;
    if (itemLen<128)
    { 
      /* the length field of the fragmentation is 1 byte */
      PerSkip(b,1);
      PerEncLenDeter(b, &itemLen, 1);
      /* skip itemLen + 1 bytes and put the fragment back(wards) dude */
      PerSkip(b,itemLen + 1);
      PerPutSeg(b, fragment, itemLen);
      free(fragment);
      /* Now skip back 1 + fragLen2 + 1 byte */
      *b = bsave1;
    itemLen = 2 + fragLen2 + itemLen;
    }
    else
    {
      /* itemLen < 16K 
       * the length field of the fragmentation is 2 bytes */
      PerSkip(b,2);
      PerEncLenDeter(b, &itemLen, 1);
      /* skip itemLen + 2 bytes and put the fragment back(wards) dude */
      PerSkip(b,itemLen + 2);
      PerPutSeg(b, fragment, itemLen);
      free(fragment);
      /* Now skip back 1 + fragLen2 + 2 byte */
      *b = bsave1; 
      itemLen = 3 + fragLen2 + itemLen;
    }
    }
    else
    {
      itemLen += fragLen1;
    }
    totalLen += itemLen;

    itemLen = PerEncOid(b, (&v->privDst));
    itemLen += PerEncLenDeter( b, &itemLen, 1);

    totalLen += itemLen;

    return (totalLen);

}  /* PerEncSnmpPrivMsg */ 

	STATUS
PerDecSnmpPrivMsg(BUF_TYPE b, SnmpPrivMsg* v) 
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen, elmtLen1, elmtLen2;
    AsnLen fragLen1, fragLen2;
    char	*bsave1;
    char	*bsave2;
    char*  fragment;
    totalElmtsLen += PerDecLenDeter(b, &elmtLen , 1);
    PerDecOid( b, (&v->privDst), elmtLen);
    totalElmtsLen += elmtLen;

    fragLen1 = PerDecLenDeter(b, &elmtLen1, 1);  
   
    bsave1 = *b;
    if (fragLen1 == 3)
    {
     /* skip to next length field of the remaining part*/
     PerSkip(b, elmtLen1);
     /* save the pointer */
     bsave2 = *b;
     /* determine the length of the remaining part */
     fragLen2 = PerDecLenDeter(b, &elmtLen2, 1);
     /* copy that part */
     fragment = (char *) malloc(elmtLen2);
     PerCopy(fragment, b, elmtLen2);
     /* put the part at the saved pointer back(wards) */
     *b = bsave2;
     PerSkip(b, elmtLen2);
     PerPutSeg( b, fragment, elmtLen2);
     free(fragment);
     totalElmtsLen += (1 + elmtLen1 + fragLen2 + elmtLen2);
     v->privData.octetLen = (elmtLen1 + elmtLen2);
     *b = bsave1;
    }
    else
    {
     totalElmtsLen += fragLen1;
     totalElmtsLen += elmtLen1; 
     v->privData.octetLen = elmtLen1;
    } 
    
    v->privData.octs = *b;

    return( OK );
}  /* PerDecSnmpPrivMsg */


AsnLen
PerEncSnmpAuthMsg( BUF_TYPE b, SnmpAuthMsg*  v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    itemLen = v->authData.octetLen; /* authData is already encoded :) */
    
    totalLen += itemLen;

    itemLen = PerEncSnmpAuthMsgChoice( b, (v->authInfo));

    totalLen += itemLen;

    return (totalLen);

}  /* PerEncSnmpAuthMsg */

STATUS
PerDecSnmpAuthMsg(BUF_TYPE b, SnmpAuthMsg* v, AsnLen totalLen)
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;


    (v->authInfo) = (SnmpAuthMsgChoice*) Asn1Alloc(sizeof(SnmpAuthMsgChoice));
    totalElmtsLen += PerDecSnmpAuthMsgChoice( b, (v->authInfo));
  
    v->authData.octs = *b;
    v->authData.octetLen = (totalLen - totalElmtsLen);
		/* The length of the authData component */
	
    
    return( OK );

}  /* PerDecSnmpAuthMsg */


AsnLen
PerEncSnmpMgmtCom( BUF_TYPE b, SnmpMgmtCom* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    itemLen = PerEncSnmpMgmtComChoice( b, (v->operation));

    totalLen += itemLen;

    itemLen = PerEncOid( b, (&v->context));
    itemLen += PerEncLenDeter( b, &itemLen, 1);

    totalLen += itemLen;

    itemLen = PerEncOid( b, (&v->srcParty));
    itemLen += PerEncLenDeter( b, &itemLen, 1);

    totalLen += itemLen;

    itemLen = PerEncOid( b, (&v->dstParty));
    itemLen += PerEncLenDeter( b, &itemLen, 1);

    totalLen += itemLen;

    return (totalLen);

}  /* PerEncSnmpMgmtCom */

	STATUS
PerDecSnmpMgmtCom(BUF_TYPE b, SnmpMgmtCom* v, AsnLen totalLen) 
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;



    totalElmtsLen += PerDecLenDeter (b, &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecOid(b, (&v->dstParty), elmtLen);

    totalElmtsLen += PerDecLenDeter (b, &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecOid(b, (&v->srcParty), elmtLen);

    totalElmtsLen += PerDecLenDeter (b, &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecOid(b, (&v->context), elmtLen);


    (v->operation) = (SnmpMgmtComChoice*) Asn1Alloc(sizeof(SnmpMgmtComChoice));
    PerDecSnmpMgmtComChoice( b, (v->operation), (totalLen - totalElmtsLen));

    return( OK );
}  /*  PerDecSnmpMgmtCom */



AsnLen
PerEncPDUs(BUF_TYPE b, PDUs* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

	/*
	 * In the following part a padded bit field shall
	 * be created to make a difference between the
	 * different choices
	 * 7 choices encoded into a 3 bit field,
	 * appended by 5 zero bits for padding
	 * e.g SNMPv2_TRAP has value 6 (110b) plus 5 zero
	 * bits makes 11000000b = 192
	 * Remark: This can only be done because in this
	 *	   case the ALGINED variant is chosen. After
	 *	   This CHOICE field an octet-aligned field follows
	 *	   (request-id it's length field)
	 */

    switch(v->choiceId)
    {
       case(PDUS_GET_REQUEST):
    itemLen = PerEncPDU( b, (v->a.get_request));
    PerEncLenCons( b, 0, 5);
    /* One byte will be prepended to make a difference
     * between the choice types.
     * With get_request this value is 0000 0000
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(PDUS_GET_NEXT_REQUEST):
    itemLen = PerEncPDU( b, (v->a.get_next_request));
    PerEncLenCons( b, 1, 5);
    /* One byte will be prepended to make a difference
     * between the choice types.
     * With get_next_request this value is  0010 0000 b
     */
    itemLen++;


    totalLen += itemLen;

    break;

       case(PDUS_RESPONSE):
    itemLen = PerEncPDU( b, (v->a.response));
    PerEncLenCons( b, 2, 5);
    /* One byte will be prepended to make a difference
     * between the choice types.
     * With response this value is 0100 0000 b 
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(PDUS_SET_REQUEST):
    itemLen = PerEncPDU( b, (v->a.set_request));
    PerEncLenCons( b, 3, 5);
    /* One byte will be prepended to make a difference
     * between the choice types.
     * With set_request this value is 0110 0000 b 
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(PDUS_GET_BULK_REQUEST):
    itemLen = PerEncBulkPDU( b, (v->a.get_bulk_request));
    PerEncLenCons( b, 4, 5);
    /* One byte will be prepended to make a difference
     * between the choice types.
     * With get_bulk_request this value is 1000 0000 b 
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(PDUS_INFORM_REQUEST):
    itemLen = PerEncPDU( b, (v->a.inform_request));
    PerEncLenCons( b, 5, 5);
    /* One byte will be prepended to make a difference
     * between the choice types.
     * With inform_request this value is 1010 0000 b 
     */
    itemLen++;

    totalLen += itemLen;

    break;

       case(PDUS_SNMPV2_TRAP):
    itemLen = PerEncPDU( b, (v->a.snmpV2_trap));
    PerEncLenCons( b, 6, 5);
    /* One byte will be prepended to make a difference
     * between the choice types.
     * With snmpV2_trap this value is 1100 0000 b 
     */
    itemLen++;

    totalLen += itemLen;

    break;

    }
    return (totalLen);

}  /* PerEncPDUs */

	STATUS
PerDecPDUs(BUF_TYPE b, PDUs* v, PDUsChoiceId tag)
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;



    switch(tag)
    {
       case(PDUS_GET_REQUEST):
        (v->choiceId) = PDUS_GET_REQUEST;
    (v->a.get_request) = (GetRequest_PDU*) Asn1Alloc(sizeof(GetRequest_PDU));
    PerDecPDU( b, (v->a.get_request));
    break;

       case(PDUS_GET_NEXT_REQUEST):
        (v->choiceId) = PDUS_GET_NEXT_REQUEST;
    (v->a.get_next_request) = (GetNextRequest_PDU*) Asn1Alloc(sizeof(GetNextRequest_PDU));
    PerDecPDU( b, (v->a.get_next_request));
    break;

       case(PDUS_RESPONSE):
        (v->choiceId) = PDUS_RESPONSE;
    (v->a.response) = (Response_PDU*) Asn1Alloc(sizeof(Response_PDU));
    PerDecPDU( b, (v->a.response));
    break;

       case(PDUS_SET_REQUEST):
        (v->choiceId) = PDUS_SET_REQUEST;
    (v->a.set_request) = (SetRequest_PDU*) Asn1Alloc(sizeof(SetRequest_PDU));
    PerDecPDU( b, (v->a.set_request));
    break;

       case(PDUS_GET_BULK_REQUEST):
        (v->choiceId) = PDUS_GET_BULK_REQUEST;
    (v->a.get_bulk_request) = (GetBulkRequest_PDU*) Asn1Alloc(sizeof(GetBulkRequest_PDU));
    PerDecBulkPDU( b, (v->a.get_bulk_request));
    break;

       case(PDUS_INFORM_REQUEST):
        (v->choiceId) = PDUS_INFORM_REQUEST;
    (v->a.inform_request) = (InformRequest_PDU*) Asn1Alloc(sizeof(InformRequest_PDU));
    PerDecPDU( b, (v->a.inform_request));
    break;

       case(PDUS_SNMPV2_TRAP):
        (v->choiceId) = PDUS_SNMPV2_TRAP;
    (v->a.snmpV2_trap) = (SNMPv2_Trap_PDU*) Asn1Alloc(sizeof(SNMPv2_Trap_PDU));
    PerDecPDU( b, (v->a.snmpV2_trap));
    break;

    default:
        Asn1Error("ERROR - unexpected PER PDUs CHOICE\n");
        return( FAILED );
    break;
    }
    return( OK );
}   /* PerDecPDUs */


