/* -----------------------------------------------------------------------
 *
 * Project:     UT-SNMP
 *
 * Filename:    spmPartyMIB.c
 *
 * Date:        May 1994
 *
 * Purpose:     This file contains the primairy hashing functions.
 *
 * Author( s):  Koert W. G. Flapper
 *
 * -----------------------------------------------------------------------
 */
#include <spmHash.h>

/* -----------------------------------------------------------------------
 * Function:    hashoid
 * Arguments:   
 * Purpose:     hash an object identifier to a hashtable entry
 * Remarks:     
 * -----------------------------------------------------------------------
 */
int hashoid( AsnOid *oid, int size, int radix )
{
	register unsigned	tot;
	register int	i;

	for( tot = 0, i = oid->octetLen-1; i >= 0; i--)
		tot = tot * radix + oid->octs[i];
	return tot % size;
}

/* -----------------------------------------------------------------------
 * Function:    hashclear
 * Arguments:   struct Hashnode	*hashtab[];
 * Purpose:     Clears the hashtable
 * Remarks:     
 * -----------------------------------------------------------------------
 */

void	hashclear( hashtab, size)
struct Hashnode	*hashtab[];
int		size;
{
	int	i;
	struct Hashnode		**dphn;

	/* clear the hash table */
	dphn = &hashtab[0];
	for (i=0; i< size; i++)
		*dphn++ = 0;
}
