/* -----------------------------------------------------------------------
 *
 * Project:	SNMPV2
 *
 * Filename:    spmSnmpAPI.c
 *
 * Date:        April 1994
 *
 * Purpose:     This file contains the snmpv2mib API to the meta-manager.
 *
 * Author( s):  Koert W.G. Flapper
 *
 * -----------------------------------------------------------------------
 */

#include <spmSnmpMIB.h>

int	snmpv2msize = 18, snmpv2tsize = 0;

struct MibRecord snmpv2mibtab[] = {
	{ "snmpMIB", { 6, "\53\6\1\6\3\1" }, AGGREGATE, FALSE, FALSE, 0, 0, 0},
	{ "snmpMIBObjects", { 7, "\53\6\1\6\3\1\1" }, AGGREGATE, FALSE, 0, 0, 0},
	{ "snmpStats", { 8, "\53\6\1\6\3\1\1\1" }, AGGREGATE, FALSE, FALSE, 0, 0, 0},
	{ "snmpStatsPackets", { 9, "\53\6\1\6\3\1\1\1\1" }, ASN1_COUNTER, FALSE, TRUE, MibItemRequest, (AsnInt) &SnmpStats[snmpStatsPackets], 0},
	{ "snmpStats30Something", { 9, "\53\6\1\6\3\1\1\1\2" }, ASN1_COUNTER, FALSE, TRUE, MibItemRequest, (AsnInt)&SnmpStats[snmpStats30Something], 0},
	{ "snmpStatsEncodingErrors", { 9, "\53\6\1\6\3\1\1\1\3" }, ASN1_COUNTER, FALSE, TRUE, MibItemRequest, (AsnInt)&SnmpStats[snmpStatsEncodingErrors], 0},
	{ "snmpStatsUnknownDstParties", { 9, "\53\6\1\6\3\1\1\1\4" }, ASN1_COUNTER, FALSE, TRUE, MibItemRequest, (AsnInt)&SnmpStats[snmpStatsUnknownDstParties], 0},
	{ "snmpStatsDstPartyMismatches", { 9, "\53\6\1\6\3\1\1\1\5" }, ASN1_COUNTER, FALSE, TRUE, MibItemRequest, (AsnInt)&SnmpStats[snmpStatsDstPartyMismatches], 0},
	{ "snmpStatsUnknownSrcParties", { 9, "\53\6\1\6\3\1\1\1\6" }, ASN1_COUNTER, FALSE, TRUE, MibItemRequest, (AsnInt)&SnmpStats[snmpStatsUnknownSrcParties], 0},
	{ "snmpStatsBadAuths", { 9, "\53\6\1\6\3\1\1\1\7" }, ASN1_COUNTER, FALSE, TRUE, MibItemRequest, (AsnInt)&SnmpStats[snmpStatsBadAuths], 0},
	{ "snmpStatsNotInLifetimes", { 9, "\53\6\1\6\3\1\1\1\10" }, ASN1_COUNTER, FALSE, TRUE, MibItemRequest, (AsnInt)&SnmpStats[snmpStatsNotInLifetimes], 0},
	{ "snmpStatsWrongDigestValues", { 9, "\53\6\1\6\3\1\1\1\11" }, ASN1_COUNTER, FALSE, TRUE, MibItemRequest, (AsnInt)&SnmpStats[snmpStatsWrongDigestValues], 0},
	{ "snmpStatsUnknownContexts", { 9, "\53\6\1\6\3\1\1\1\12" }, ASN1_COUNTER, FALSE, TRUE, MibItemRequest, (AsnInt)&SnmpStats[snmpStatsUnknownContexts], 0},
	{ "snmpStatsBadOperations", { 9, "\53\6\1\6\3\1\1\1\13" }, ASN1_COUNTER, FALSE, TRUE, MibItemRequest, (AsnInt)&SnmpStats[snmpStatsBadOperations], 0},
	{ "snmpStatsSilentDrops", { 9, "\53\6\1\6\3\1\1\1\14" }, ASN1_COUNTER, FALSE, TRUE, MibItemRequest, (AsnInt)&SnmpStats[snmpStatsSilentDrops], 0},
	{ "snmpV1", { 8, "\53\6\1\6\3\1\1\2" }, AGGREGATE, FALSE, FALSE, 0, 0, 0},
	{ "snmpV1BadCommunityNames", { 9, "\53\6\1\6\3\1\1\2\1" }, ASN1_COUNTER, FALSE, TRUE, MibItemRequest, (AsnInt)&SnmpV1[snmpV1BadCommunityNames], 0},
	{ "snmpV1BadCommunityUses", { 9, "\53\6\1\6\3\1\1\2\2" }, ASN1_COUNTER, FALSE, TRUE, MibItemRequest, (AsnInt)&SnmpV1[snmpV1BadCommunityUses], 0}
};

struct TabRecord snmpv2tabtab[] = {};
